#!/usr/bin/ruby -KU
# plagiarism.cgi
=begin
    Copyright (C) 2008  Tomáš Gregorovič, _tom_ at centrum.cz

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
=end

start_time = Time.now
 
require 'cgi'
require 'cgi/session'
require 'cgi/session/pstore'
require 'pagecomposer'
require 'textparser'
require 'plagiarism'

cgi = CGI.new('html4')

session = CGI::Session.new(cgi,
      'database_manager' => CGI::Session::PStore,  # use PStore
      'session_key' => 'id',                       # custom session key
      'session_expires' => Time.now + 30 * 60,     # 30 minute timeout
      'prefix' => 'id_')                           # PStore option
      
api = session['plagiarism']
if api == nil then
  # get query attributes value  
  maxchunklen = 40
  if cgi.key?('chunk') then
    maxchunklen = cgi['chunk'].to_i
  end
  
  api = Plagiarism.new(ParsedPattern.new(cgi["text"], maxchunklen))
end

page = PageComposer.new
 
if cgi.key?('url') then
  item = api.results[cgi['url']]
  page.out('doc.rhtml')
else
  if cgi.key?('errors') then
    page.out('errors.rhtml')
  else
    if cgi.key?('hidden') then
      page.out('hidden.rhtml')
    else
      if cgi.key?('hiddenresults') then
        page.out('hiddenresults.rhtml')
      else
	  if cgi.key?('queries') then
        page.out('queries.rhtml')
      else
      if cgi.key?('results') then
        page.out('results.rhtml')
      else
        api.newstep
        
        # get query attributes value  
        similar = 0
        if cgi.key?('similar') then
          similar = cgi['similar']
        end
        
        from = 0
        if cgi.key?('from') then
          from = cgi['from'].to_i
        end
        
        count = 10
        if cgi.key?('count') then
          count = cgi['count'].to_i
        end
        
        if api.results.length == 0 or api.searchfrom < from then
          api.find(similar, from)
        end
        
        if api.resultcount < count then
          api.checksimilarity(count)
        end
        
        hiddenresults = 0
        api.resultlist.each { |item|
          if item.itemtype == :hiddenresult then
            hiddenresults = hiddenresults + 1
          end      
        }
  
        errors = 0
        hidden = 0
        api.documentlist.each { |item|
          case item.itemtype
          when :error
            errors = errors + 1
          when :hidden
            hidden = hidden + 1 
          end
        }

        session['plagiarism'] = api
  
        pagetitle = 'Aplikace Plagiáty z webu &ndash; podobné dokumenty'
        pagebody = IO.read('app.rhtml')
        
        page.out
      end
      end
	  end
    end
  end
end

session.update

